﻿using Infragistics.Win;
using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.UltraWinTree;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp4
{
    public partial class Form1 : Form
    {
        private UltraTreeNodeColumn _colName;
        private UltraTreeNodeColumn _colValue;

        public Form1()
        {
            InitializeComponent();

            //UltraTreeNode nodeA;
            //UltraTreeNode nodeB;
            //// Add two nodes to the WinTree
            //nodeA = this.ultraTree1.Nodes.Add("nodeA", "NodeA");
            //nodeB = this.ultraTree1.Nodes.Add("nodeB", "NodeB");
            //// Expand the newly added node
            //nodeA.Expanded = true;
            //// Add a child node to Node A
            //nodeA.Nodes.Add("childNodeofA", "ChildNodeA1");
            //// Add Node C to WinTree
            //this.ultraTree1.Nodes.Add("nodeC", "NodeC");
            //// Get a reference to Node C using its key
            //UltraTreeNode nodeC = this.ultraTree1.GetNodeByKey("nodeC");
            //// Add a child node to NodeC
            //nodeC.Nodes.Add("childNodeofC", "ChildNodeC1");
            //// Remove NodeB
            ///

            this.ultraTree1.Nodes.Clear();

            // set outlook view style:
            this.ultraTree1.ViewStyle = ViewStyle.OutlookExpress;
            this.ultraTree1.Indent = 10;

            // Editable cells:
            this.ultraTree1.Override.CellClickAction = CellClickAction.EditCell;

            // Only allow one node to be selected at a time
            this.ultraTree1.Override.SelectionType = SelectType.Single;

            // Use single-pixel borders of 'Control' color for the cells
            this.ultraTree1.ColumnSettings.BorderStyleCell = UIElementBorderStyle.Solid;
            this.ultraTree1.ColumnSettings.CellAppearance.BorderColor = SystemColors.Control;

            // Hide the headers:
            this.ultraTree1.ColumnSettings.LabelPosition = NodeLayoutLabelPosition.None;

            // Add colums:
            UltraTreeColumnSet rootColumnSet = this.ultraTree1.ColumnSettings.RootColumnSet;
            _colName = rootColumnSet.Columns.Add("Name");
            _colName.DataType = typeof(string);
            _colName.LayoutInfo.PreferredCellSize = new Size(this.ultraTree1.Width / 2, 0);

            _colValue = rootColumnSet.Columns.Add("Value");
            _colValue.DataType = typeof(object);
            _colValue.LayoutInfo.PreferredCellSize = new Size(this.ultraTree1.Width / 2, 0);
            _colValue.AllowCellEdit = AllowCellEdit.Full;
   


            String str = "Hello world";

            UltraTreeNode node5 = this.ultraTree1.Nodes.Add(null, "");
            EditorWithText textEditor = new EditorWithText();
            textEditor.AfterEnterEditMode += Editor_AfterEnterEditMode;
            node5.Cells[_colValue].Editor = textEditor;
            node5.SetCellValue(_colName, "String2");
            node5.SetCellValue(_colValue, str);

            UltraTreeNode node6 = this.ultraTree1.Nodes.Add(null, "");
            EditorWithText textEditor2 = new EditorWithText();
            textEditor2.AfterEnterEditMode += Editor_AfterEnterEditMode;
            node6.Cells[_colValue].Editor = textEditor2;
            node6.SetCellValue(_colName, "String2");
            node6.SetCellValue(_colValue, str);
        }

        private void Editor_AfterEnterEditMode(object sender, EventArgs e)
        {
            EditorWithText editor = (EditorWithText)sender;
            editor.SelectAll();
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            this.ultraTree1.Override.LabelEdit = Infragistics.Win.DefaultableBoolean.True;

            ultraTree1.PerformAction(UltraTreeAction.EnterEditMode, false, false);

        }
    }
}
